#
# $Header: /scratch/fock/cvsroot/xd/xdgraph/tcl/guiFileMenu.tcl,v 1.5 1999/05/13 10:34:26 richter Rel $
#
#
# $Log: guiFileMenu.tcl,v $
# Revision 1.5  1999/05/13 10:34:26  richter
# removed old proc guiLoadFile
#
# Revision 1.4  1996/11/07 17:13:39  richter
# added a (preliminary) hardcopy menu entry
#
# Revision 1.3  1996/09/14  09:30:54  richter
# check if FSBox returned a directory name before calling write_logfile
#
# Revision 1.2  1996/09/06  12:48:49  richter
# guiWriteLogfile and guiSourceScript
#
# Revision 1.1  1996/05/23  07:42:20  richter
# Initial revision
#
#

proc guiFileMenu {w} {
    global active

    set active(dataset) ""
    menubutton $w -text File -underline 0 -menu $w.menu 
#Cljf remove default tearoff property of menu
#    set m [menu $w.menu]
    set m [menu $w.menu -tearoff off]
    $m add command -label "Load Dataset ..." -command "guiConfigure dataset"
#    $m add command -label "Set Active Dataset" -command guiSetActiveDset
    $m add separator
    $m add command -label "Source Script ..." -command guiSourceScript
    $m add command -label "Write Logfile ..." -command guiWriteLogfile
    $m add command -label "Hardcopy" -command hardcopy
    $m add separator
    $m add command -label "Driver Options ..." -command "guiConfigure driver"
    $m add separator
    $m add command -label Exit -command exit
}

proc guiSourceScript {} {
    global xd_tk_major xd_pwd xd_use_fsbox

    if {$xd_use_fsbox == "xd"} {
	set file [FSBox "" -modal yes -pwd $xd_pwd -filter *.tcl]
    } else {
	set file [tk_getOpenFile \
		      -filetypes {{{TCL Scripts} {.tcl}} {{All Files} *}}]
    }
	
    if {$file != ""} {
	if {[file isfile $file]} {
##	puts "source $file"
	    source $file
	} else {
	    error "Does not exist or is no regular file: \'$file\'"
	}
    }
}

proc guiWriteLogfile {} {
    global xd_tk_major xd_pwd xd_use_fsbox

    set default xdgraph.log
    if {$xd_use_fsbox == "xd"} {
	set file [FSBox "" -modal yes -pwd $xd_pwd -filter $default]
    } else {
	set file [tk_getSaveFile -initialfile $default]
    }
    if {$file != ""} {
	if {[file isdirectory $file]} {
	    write_logfile $file/$default
	} else {
	    write_logfile $file
	} 
    }
}

proc guiSetActiveDset {} {
    global xd_tk_major active

    set dsets [dataset]
    set w [guiDialogFrame .set_active_dset "Set Active Dataset"]
    
    set f [frame $w.list -bd 5]
    frame $f.vsl
    listbox $f.vsl.list -exportselection no \
        -yscrollcommand "$f.vsl.scroll set" \
        -xscrollcommand "$f.hsl.scroll set"
    if {$xd_tk_major < 4} {
         tk_listboxSingleSelect $f.vsl.list
    }
    scrollbar $f.vsl.scroll -relief sunken -width 15 -borderwidth 2 \
        -command "$f.vsl.list yview"
    pack $f.vsl.list -side left
    pack $f.vsl.scroll -side right -expand yes -fill both

    frame $f.hsl
    scrollbar $f.hsl.scroll -relief sunken -width 15 -borderwidth 2 \
        -orient horizontal -command "$f.vsl.list xview"
    frame $f.hsl.filler -width 19
    pack $f.hsl.scroll -side left -expand yes -fill both
    pack $f.hsl.filler -side right

    pack $f.vsl $f.hsl -side top -expand yes -fill both
    
    foreach d [dataset] {
	$f.vsl.list insert end $d
    }

    bind $f.vsl.list <ButtonRelease-1> "set_active_from_sel $f.vsl.list"

    set f [frame $w.selection -bd 5]
    label $f.label -text "Active Dataset" -anchor sw
    entry $f.entry -textvariable active(dataset)
    pack $f.label $f.entry -side top -expand yes -fill both

    set f [frame $w.buttons -bd 5]
    button $w.buttons.ok -text OK -width 6 -padx 2 \
        -command "destroy $w"
    pack $w.buttons.ok -side left -expand yes

    pack $w.list $w.selection $w.buttons -expand yes -fill x
}

proc set_active_from_sel {w} {
    global active

    set index [$w curselection]
    if {"$index" == ""} {
        return
    }
    set active(dataset) [$w get $index]
}
    
proc guiDialogFrame {w {title ""}} {

    if {[winfo exists $w]} {
	wm deiconify $w
	raise $w
    } else {
	toplevel $w -bd 5
	if {[string compare $title ""] != 0} {
	    wm title $w $title
	}
    }

    return $w
}
