#
# $Header: /scratch/fock/cvsroot/xd/xdgraph/tcl/guiViewsMenu.tcl,v 1.3 1999/06/03 12:36:27 richter Exp $
#
#
# $Log: guiViewsMenu.tcl,v $
# Revision 1.3  1999/06/03 12:36:27  richter
# first throw at removable views
#
# Revision 1.2  1996/09/06 12:51:26  richter
# mark active view
# configure and set active menu entries
#
# Revision 1.1  1996/05/23  07:42:22  richter
# Initial revision
#
#

proc guiViewsMenu {w} {
    global xd_tk_major

    menubutton $w -text Views -underline 0 -menu $w.menu 
    menu $w.menu -postcommand [list rebuild_view_menu $w.menu]
    if {$xd_tk_major >= 4} {
	$w.menu configure -tearoff off
    }
}

proc add_view_entry {w name} {
    global active

    set m $w.v-$name
    if {[string compare $active(view) $name] == 0} {
	set label "$name*"
    } else {
	set label $name
    }
    $w add cascade -label $label -menu $m
    if {![winfo exists $m]} {
#Cljf remove default tearoff property of menu
#        menu $m  
        menu $m  -tearoff off
	$m add command -label "set active view" \
	    -command "set active(view) $name"
	$m add command -label "configure ..." \
	    -command "guiConfigure view $name"
	$m add command -label "plot" -command "doCommand \"plot $name\""
	$m add command -label "clear" -command "doCommand \"clear $name\""
	$m add command -label "remove" \
	    -command [list doCommand [list remove $name]]
    }
}

proc rebuild_view_menu {w} {
    global xd_tk_major

    set last [$w index last]
    if {[string compare $last none]} {
	for {set i 0} {$i <= $last} {incr i} {
	    if {$xd_tk_major >=4} {
		if {[string compare [$w type $i] cascade]==0} {
		    destroy [$w entrycget $i -menu]
		}
	    } else {
		set c [lindex [$w entryconfig $i -menu] 4]
		if {[string compare $c ""]} {
		    destroy $c
		}
	    }
	}
	$w delete 0 last
    }

    foreach view [view] {
	add_view_entry $w $view
    }
}
